# calcshift.cl --- calculate image offset 
# Yosuke Minowa (2008/06/30)

procedure calcshift (objlist, output)

file objlist   {prompt="List of input images with @mark"}
file reference {prompt="Reference image"}
file output    {prompt="Name of output offset data"}
char region    {"[1:1024,1:1024]",prompt="Image region for cross-correlation"}
int crmargin   {prompt="Margin to strip down (crossdriz)"}
int crtapersz  {prompt="Edge region to taper (crossdriz)"}
real crboxsize {prompt="Box size where to search for peak (shiftfind)"}

begin
	char _output, _objlist, _reference, _region
	char tmp_objlist, tmp_regfile, tmp_refimg, tmp_regimg, tmp_crfile, tmp_crimg, tmp_shift
	real _crboxsize
	char fname
	int inum
	int _crmargin, _crtapersz
	real tmp1, tmp2, tmp3
	real xshift, yshift, dxshift, dyshift

	_objlist = objlist
	_output = output
	_crmargin = crmargin
	_crtapersz = crtapersz
	_crboxsize = crboxsize
	_region = region
	_reference = reference

	if(access(_output)){
		print("Operation would overwrite ",_output)
	}else{
		tmp_objlist = mktemp("tmp_file.")
		sections(_objlist,option='fullname',>tmp_objlist)

		tmp_regfile = mktemp("tmp_file.")

		list = tmp_objlist
		while(fscan(list,fname) != EOF){
			tmp_regimg = mktemp("tmp_img.")
			imcopy(fname//_region,tmp_regimg,ver+)
			print(tmp_regimg,>> tmp_regfile)
		}
		tmp_refimg = mktemp("tmp_img.")
		imcopy(_reference//_region, tmp_refimg, ver+)

		del(tmp_objlist,ver-,>&"dev$null")

		tmp_crfile = mktemp("tmp_file.")
		list = tmp_regfile
		while(fscan(list,fname) != EOF){
			tmp_crimg = mktemp("tmp_img.")
			crossdriz (fname, tmp_refimg, tmp_crimg, dinp=no, dref=no, margin=_crmargin, tapersz=_crtapersz, mintheta=0., maxtheta=0., stptheta=0.1, coeffs="", lambda=555., expkey="exptime", xout=INDEF, yout=INDEF, pad=yes, tempdir="tmp$", verbose=yes, dummy=no)
			print(tmp_crimg, >> tmp_crfile)
		}

		tmp_shift = mktemp("tmp_data.")
		shiftfind ("@"//tmp_crfile, tmp_shift, xshift=INDEF, yshift=INDEF, boxsize=_crboxsize, fwhm=7., ellip=0.05, pa=45., fitbox=7, kellip=yes, kpa=yes, tempdir="tmp$")
		list = tmp_shift
		while(fscan(list,fname, tmp1, xshift, dxshift, yshift, dyshift, tmp2, tmp3) != EOF){
			print(xshift, yshift, >> _output)
		}
	
		imdel(tmp_refimg)
		imdel("@"//tmp_regfile)
		del(tmp_regfile,ver-,>&"dev$null")
		imdel("@"//tmp_crfile)
		del(tmp_crfile,ver-,>&"dev$null")
		del(tmp_shift,ver-,>&"dev$null")
	}
end
