# calcshift_mod.cl --- calculate image offset 
# Yosuke Minowa (2008/10/09)

procedure calcshift_mod (objlist, output)

file objlist   {prompt="List of input images with @mark"}
file reference {prompt="Reference image"}
file output    {prompt="Name of output offset data"}
int  xmin      {prompt="X min"}
int  xmax      {prompt="X min"}
int  ymin      {prompt="Y min"}
int  ymax      {prompt="Y max"}
real dithwidth {50, prompt="Default offset"}
int  numdith   {9, prompt="Dumber of dithering positions"}
int crmargin   {prompt="Margin to strip down (crossdriz)"}
int crtapersz  {prompt="Edge region to taper (crossdriz)"}
real crboxsize {prompt="Box size where to search for peak (shiftfind)"}

begin
	char _output, _objlist, _reference, region
	char tmp_objlist, tmp_regfile, tmp_refimg, tmp_regimg, tmp_crfile, tmp_crimg, tmp_shift
	real _crboxsize
	char fname
	int inum
	int _crmargin, _crtapersz
	int _numdith
	int ref_dthpos, img_dthpos
	int x_defoffset, y_defoffset
	int _dithwidth
	real __dithwidth
	real tmp1, tmp2, tmp3
	int _xmin, _xmax, _ymin, _ymax
	int _xmin0, _xmax0, _ymin0, _ymax0
	real xshift, yshift, dxshift, dyshift

	_objlist = objlist
	_output = output
	_crmargin = crmargin
	_crtapersz = crtapersz
	_crboxsize = crboxsize
	_reference = reference
	__dithwidth = dithwidth
	_numdith = numdith
	_xmin0 = xmin
	_xmax0 = xmax
	_ymin0 = ymin
	_ymax0 = ymax

	_dithwidth = int(__dithwidth)
	print(_dithwidth)

	if(access(_output)){
		print("Operation would overwrite ",_output)
	}else{
		hselect(_reference, "I_DTHPOS", yes) | scan(ref_dthpos)
		
		if(ref_dthpos != 1){
		   print "Error: reference image should be 1st dithering position")
		   bye
		}
		
		tmp_objlist = mktemp("tmp_file.")
		sections(_objlist,option='fullname',>tmp_objlist)

		tmp_regfile = mktemp("tmp_file.")

		list = tmp_objlist
		while(fscan(list,fname) != EOF){
			_xmin = _xmin0
			_xmax = _xmax0
			_ymin = _ymin0
			_ymax = _ymax0

			hselect(fname, "I_DTHPOS", yes) | scan(img_dthpos)
			if(_numdith == 9){
		            if(img_dthpos == 1){
			        _xmin = _xmin
			        _xmax = _xmax
			        _ymin = _ymin
			        _ymax = _ymax
				x_defoffset = 0
				y_defoffset = 0
			    }else if(img_dthpos == 2){
			        _xmin = _xmin + _dithwidth
			        _xmax = _xmax + _dithwidth
			        _ymin = _ymin - _dithwidth
			        _ymax = _ymax - _dithwidth
				x_defoffset = _dithwidth
				y_defoffset = -_dithwidth
			    }else if(img_dthpos == 3){
			        _xmin = _xmin + _dithwidth
			        _xmax = _xmax + _dithwidth
				x_defoffset = _dithwidth
				y_defoffset = 0
			    }else if(img_dthpos == 4){
			        _xmin = _xmin + _dithwidth
			        _xmax = _xmax + _dithwidth
			        _ymin = _ymin + _dithwidth
			        _ymax = _ymax + _dithwidth
				x_defoffset = _dithwidth
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 5){
			        _ymin = _ymin + _dithwidth
			        _ymax = _ymax + _dithwidth
				x_defoffset = 0
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 6){
			        _xmin = _xmin - _dithwidth
			        _xmax = _xmax - _dithwidth
			        _ymin = _ymin + _dithwidth
			        _ymax = _ymax + _dithwidth
				x_defoffset = -_dithwidth
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 7){
			        _xmin = _xmin - _dithwidth
			        _xmax = _xmax - _dithwidth
				x_defoffset = -_dithwidth
				y_defoffset = 0
			    }else if(img_dthpos == 8){
			        _xmin = _xmin - _dithwidth
			        _xmax = _xmax - _dithwidth
			        _ymin = _ymin - _dithwidth
			        _ymax = _ymax - _dithwidth
				x_defoffset = -_dithwidth
				y_defoffset = -_dithwidth
			    }else if(img_dthpos == 9){
			        _ymin = _ymin - _dithwidth
			        _ymax = _ymax - _dithwidth
				x_defoffset = 0
				y_defoffset = -_dithwidth
			    }else{
			        print("Error: cannot read dithering position from fits header")
				bye
			    }
			}else if(_numdith == 5){
		            if(img_dthpos == 1){
			        _xmin = _xmin
			        _xmax = _xmax
			        _ymin = _ymin
			        _ymax = _ymax
				x_defoffset = 0
				y_defoffset = 0
			    }else if(img_dthpos == 2){
			        _xmin = _xmin + _dithwidth
			        _xmax = _xmax + _dithwidth
			        _ymin = _ymin - _dithwidth
			        _ymax = _ymax - _dithwidth
				x_defoffset = _dithwidth
				y_defoffset = -_dithwidth
			    }else if(img_dthpos == 3){
			        _xmin = _xmin + _dithwidth
			        _xmax = _xmax + _dithwidth
			        _ymin = _ymin + _dithwidth
			        _ymax = _ymax + _dithwidth
				x_defoffset = _dithwidth
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 4){
			        _xmin = _xmin - _dithwidth
			        _xmax = _xmax - _dithwidth
			        _ymin = _ymin + _dithwidth
			        _ymax = _ymax + _dithwidth
				x_defoffset = -_dithwidth
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 5){
			        _xmin = _xmin - _dithwidth
			        _xmax = _xmax - _dithwidth
			        _ymin = _ymin - _dithwidth
			        _ymax = _ymax - _dithwidth
				x_defoffset = -_dithwidth
				y_defoffset = -_dithwidth
			    }else{
			        print("Error: cannot read dithering position from fits header")
				bye
			    }		      
			}else{
			    print("Error: numdith should be 9 or 5")
			    bye
			}
			
			tmp_regimg = mktemp("tmp_img.")
			region = "["//_xmin//":"//_xmax//","//_ymin//":"//_ymax//"]"
			imcopy(fname//region,tmp_regimg,ver+)
			print(tmp_regimg,>> tmp_regfile)
		}
		tmp_refimg = mktemp("tmp_img.")
		region = "["//_xmin0//":"//_xmax0//","//_ymin0//":"//_ymax0//"]"
		imcopy(_reference//region, tmp_refimg, ver+)

		del(tmp_objlist,ver-,>&"dev$null")

		tmp_crfile = mktemp("tmp_file.")
		list = tmp_regfile
		while(fscan(list,fname) != EOF){
			tmp_crimg = mktemp("tmp_img.")
			crossdriz (fname, tmp_refimg, tmp_crimg, dinp=no, dref=no, margin=_crmargin, tapersz=_crtapersz, mintheta=0., maxtheta=0., stptheta=0.1, coeffs="", lambda=555., expkey="exptime", xout=INDEF, yout=INDEF, pad=yes, tempdir="tmp$", verbose=yes, dummy=no)
			print(tmp_crimg, >> tmp_crfile)
		}

		tmp_shift = mktemp("tmp_data.")
		shiftfind ("@"//tmp_crfile, tmp_shift, xshift=INDEF, yshift=INDEF, boxsize=_crboxsize, fwhm=7., ellip=0.05, pa=45., fitbox=7, kellip=yes, kpa=yes, tempdir="tmp$")
		list = tmp_shift
		while(fscan(list,fname, tmp1, xshift, dxshift, yshift, dyshift, tmp2, tmp3) != EOF){

			hselect(fname, "I_DTHPOS", yes) | scan(img_dthpos)
			if(_numdith == 9){
		            if(img_dthpos == 1){
				x_defoffset = 0
				y_defoffset = 0
			    }else if(img_dthpos == 2){
				x_defoffset = _dithwidth
				y_defoffset = -_dithwidth
			    }else if(img_dthpos == 3){
				x_defoffset = _dithwidth
				y_defoffset = 0
			    }else if(img_dthpos == 4){
				x_defoffset = _dithwidth
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 5){
				x_defoffset = 0
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 6){
				x_defoffset = -_dithwidth
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 7){
				x_defoffset = -_dithwidth
				y_defoffset = 0
			    }else if(img_dthpos == 8){
				x_defoffset = -_dithwidth
				y_defoffset = -_dithwidth
			    }else if(img_dthpos == 9){
				x_defoffset = 0
				y_defoffset = -_dithwidth
			    }else{
			        print("Error: cannot read dithering position from fits header")
				bye
			    }
			}else if(_numdith == 5){
		            if(img_dthpos == 1){
				x_defoffset = 0
				y_defoffset = 0
			    }else if(img_dthpos == 2){
				x_defoffset = _dithwidth
				y_defoffset = -_dithwidth
			    }else if(img_dthpos == 3){
				x_defoffset = _dithwidth
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 4){
				x_defoffset = -_dithwidth
				y_defoffset = _dithwidth
			    }else if(img_dthpos == 5){
				x_defoffset = -_dithwidth
				y_defoffset = -_dithwidth
			    }else{
			        print("Error: cannot read dithering position from fits header")
				bye
			    }		      
			}else{
			    print("Error: numdith should be 9 or 5")
			    bye
			}

			xshift = xshift - x_defoffset
			yshift = yshift - y_defoffset
			printf("%.3f %.3f %.3f %.3f\n",xshift, yshift, dxshift, dyshift, >> _output)
		}
	
		imdel(tmp_refimg)
		imdel("@"//tmp_regfile)
		del(tmp_regfile,ver-,>&"dev$null")
		imdel("@"//tmp_crfile)
		del(tmp_crfile,ver-,>&"dev$null")
		del(tmp_shift,ver-,>&"dev$null")
	}
end
