# GROWTH -- making growth curve
#  2003/06/03  Yosuke Minowa
procedure growth(in,out)

file in     {prompt="Input image file name"}
file out    {prompt="Output growthcurve data"}
real rmin   {1,prompt="Minimum Radius of growth curve"}
real rmax   {prompt="Maximum Radius of growth curve"}
real rbin   {prompt="Resolution of growth curve"}
char salgor {prompt="Sky fitting algorithm", enum="median|mode|constant"}
real annu   {prompt="Inner Radius of sky annulus"}
real dannu  {prompt="Width of sky annulus"}
real sky    {0,prompt="Constant sky value (/pixel)"}

begin
  char img,data
  real min,max,bin
  real rtmp1,rtmp2,rtmp3,rtmp4,rtmp5,rtmp6,rtmp7,rtmp8,rtmp9,rtmp10,rtmp11
  char tmp0,tmp1,tmp2,tmp3,tmp4
  real r,flux,mag
  real sig,fwhm
  real s
  real ann,dann
  char sal
  real med

  img = in
  data = out
  min = rmin
  max = rmax
  bin = rbin
  s = sky
  ann = annu
  dann = dannu
  sal = salgor

  if(access(data)){
    print("ERROR: Operation would overwrite existing data \"",data,"\"")
  } else {

    print("\nExecuting imexam ....")
    print("INSTRUCTION: Hit'a' to select objects")
    print("INSTRUCTION: Hit 'q' to quit imexam")
    print("Warning: Do not use any command except 'a' and 'q'\n")
    
    display(img,1)
    tmp1 = mktemp("tmp_file.")
    imexamine(img,1,>> tmp1)

    tmp2 = mktemp("tmp_file.")
    tail (tmp1, nl=2, >> tmp2)
    head (tmp2, nl=1) | scan(x,y,rtmp1,rtmp2)
    tail (tmp2, nl=1) | scan(rtmp1, rtmp2, rtmp3, rtmp4, rtmp5, rtmp6, rtmp7, rtmp8, rtmp9, fwhm, rtmp11)

    del(tmp1)
    del(tmp2)

    imstat (in, fields="stddev", lower=INDEF, upper=INDEF, nclip=50,
    lsigma=3., usigma=3., binwidth=0.1, format=no, cache=no) | scan(sig)

    tmp3 = mktemp("tmp_file.")
    print (x,y,"spbar",> tmp3)

    r = min
  
    while(r <= max){
      tmp4 = mktemp("tmp_file.")

      phot (in, "", coords="", output=tmp4, plotfile="", scale=1., fwhmpsf=fwhm, emission=yes, sigma=sig, datamin=INDEF, datamax=INDEF, noise="poisson", ccdread="", gain="", readnoise=0., epadu=1., exposure="", airmass="", filter="", obstime="", itime=1., xairmass=INDEF, ifilter="INDEF", otime="INDEF", calgorithm="none", cbox=5., cthreshold=0., minsnratio=1., cmaxiter=10, maxshift=1., clean=no, rclean=1., rclip=2., kclean=3., mkcenter=no, salgorithm=sal, annulus=ann, dannulus=dann, skyvalue=s, smaxiter=10, sloclip=0., shiclip=0., snreject=50, sloreject=3., shireject=3., khist=3., binsize=0.1, smooth=no, rgrow=0., mksky=no, weighting="constant", apertures=r, zmag=INDEF, mkapert=no, interactive=no, radplots=no, icommands=tmp3, gcommands="", wcsin=")_.wcsin", wcsout=")_.wcsout", cache=")_.cache", verify=no, update=")_.update", verbose=")_.verbose",graphics=")_.graphics", display=")_.display")
    
      tail(tmp4,nl=1) |  scan(rtmp1,rtmp2,rtmp3,flux,mag,rtmp6,rtmp7,rtmp8)

      print(r, flux, >> data)

      del(tmp4)
      r += bin
    }

    del(tmp3)
  }

end
