### maskskysub.cl
### Yosuke Minowa (2008/06/30)

procedure maskskysub (fflist,sslist,masklist)

file fflist   {prompt = "List of flat fielded frames with @mark"}
file sslist   {prompt = "List of sky subtracted frames with @mark"}
file masklist {prompt = "List of object mask with @mark"}
int ndthpos   {9,prompt = "Number of dithering position"}
int iteranum  {50,prompt = "Max iteration number for statistic"}
int nsigma    {3,prompt = "Sigma rejection limit"}
struct *list1  {mode = 'h'}
struct *list2  {mode = 'h'}
struct *list3  {mode = 'h'}

begin
	char _fflist, _sslist, _masklist
	char tmp_fffile, tmp_maskfile, tmp_ssfile
	char tmp_skyimg,tmp_nmskyimg
	char ff_name,mask_name,ss_name
	string ff_subset, mask_subset, ss_subset
	char ff_root, mask_root, ss_root
	real bg_med
	int itnum,nsig
	int dthpos, dthpos_pre, npos
	int i, imax

	_fflist = fflist
	_sslist = sslist
	_masklist = masklist

	itnum = iteranum
	nsig = nsigma
	npos = ndthpos

	tmp_fffile = mktemp("tmp_file.")
	sections(_fflist,option='fullname',> tmp_fffile)

	tmp_maskfile = mktemp ("tmp_file.")		
	sections (_masklist,option='fullname',>tmp_maskfile)

	tmp_ssfile = mktemp ("tmp_file.")		
	sections (_sslist,option='fullname',>tmp_ssfile)

	list1 = tmp_fffile
	list2 = tmp_maskfile
	
	while (fscan (list1,ff_name) != EOF) {
		if (fscan (list2,mask_name) != EOF) {
			mask_name = mask_name//"[pl]"
			hedit (ff_name, "objmask", mask_name, add=yes, verify=no)
		}
	}
	
	list1 = tmp_fffile
	list2 = tmp_maskfile
	list3 = tmp_ssfile

	ff_root = mktemp("tmp_ffroot.")
	ss_root = mktemp("tmp_ssroot.")
	mask_root = mktemp("tmp_maskroot.")
	
	i = 0
	dthpos_pre = 100
	while(fscan(list1, ff_name) != EOF){
          if(fscan(list2, mask_name) != EOF){
	    if(fscan(list3, ss_name) != EOF){
	      hselect(ff_name, "I_DTHPOS", yes) | scan(dthpos)
	      if(dthpos < 1 || dthpos > ndthpos){
	        print("Error: Cannot read I_DTHPOS")
		bye
	      }
	      if(dthpos < dthpos_pre){
	        i += 1
	        print(ff_root//"_"//i//".lst") | scan(ff_subset) 
	        print(mask_root//"_"//i//".lst") | scan(mask_subset) 
	        print(ss_root//"_"//i//".lst") | scan(ss_subset) 
	        print(ff_name, > ff_subset) 
	        print(mask_name, > mask_subset)
	        print(ss_name, > ss_subset)
		dthpos_pre = dthpos 
	      }else{
	        print(ff_name, >> ff_subset)
	        print(mask_name, >> mask_subset)
	        print(ss_name, >> ss_subset)
		dthpos_pre = dthpos 
	      }
            }
          }
        }
	imax = i

	for(i=1; i<=imax;i+=1){
	      print(ff_root//"_"//i//".lst") | scan(ff_subset) 
	      print(mask_root//"_"//i//".lst") | scan(mask_subset) 
              print(ss_root//"_"//i//".lst") | scan(ss_subset) 

	      tmp_skyimg = mktemp("tmp_img.")
	      zcombine ("@"//ff_subset, tmp_skyimg, comb="median", rej="sigclip", proj=no, outtyp="real", offset="none", masktyp="!objmask", maskval=0., blan=0., scal="none", weigh="none", zerop="midpt", lthresh=INDEF, hthresh=INDEF, nlo=1., nhig=1., nkee=1., mcli=yes, lsig=3., hsig=3.)
	      imstat (tmp_skyimg, fields="midpt", lower=INDEF, upper=INDEF, nclip=itnum, lsigma=nsig, usigma=nsig, binwidth=0.1, format=no, cache=no) | scan (bg_med)
	
	      tmp_nmskyimg = mktemp("tmp_file.")
	      print ("\n### Sky background median = ",bg_med,"###\n")
	      imarith (tmp_skyimg,"/",bg_med,tmp_nmskyimg,ver+)
	      imdel(tmp_skyimg)


              list1 = ff_subset
	      list2 = mask_subset
	      list3 = ss_subset
	
              while (fscan(list1,ff_name) != EOF) {
		    if (fscan (list2,mask_name) != EOF) {
			mimstat (ff_name, imasks=mask_name//"[pl]", omasks="", fields="midpt", lower=INDEF, upper=INDEF, nclip=itnum, lsigma=nsig, usigma=nsig, binwidth=0.1, format=no, cache=no) | scan (bg_med)
			print ("\n### ",ff_name," background median = ",bg_med,"###\n")
			tmp_skyimg = mktemp("tmp_img.")
			imarith (tmp_nmskyimg,"*",bg_med, tmp_skyimg,ver+)

			if (fscan (list3,ss_name) != EOF) {
			    imarith (ff_name,"-",tmp_skyimg, ss_name,ver+)
			    imdel(tmp_skyimg)
			}
		    }
	      }

	      imdel(tmp_nmskyimg)
	      del (ff_subset,ver-,>&"dev$null")
	      del (mask_subset,ver-,>&"dev$null")
	      del (ss_subset,ver-,>&"dev$null")
	      del (tmp_fffile, ver-, >&"dev$null")
	      del (tmp_maskfile, ver-, >&"dev$null")
	      del (tmp_ssfile, ver-, >&"dev$null")
	}

end
