###  Script for making bad pixel mask
###  Yosuke Minowa (2006/12/3)
procedure mkbpmask (dark, cal, bpmask)
	
file    dark         {prompt = "Combine dark image"}
file    cal          {prompt = "Calflat image"}
file    bpmask       {prompt = "Output bad pixel mask"}

begin
	file tmpfile1, tmpfile2
	real hdthresh, lsthresh
	
	imhist (dark, z1=INDEF, z2=INDEF, binwidth=INDEF, nbins=512, autoscale=yes, top_closed=no, hist_type="normal", listout=no, plot_type="line", logy=yes, device="stdgraph")

	print ("Showing histogram of ",dark)
	print ("Input threshold for high dark current pix mask:")
	scan(hdthresh)

	tmpfile1 = mktemp("tmp_img.")
	imcopy(dark,tmpfile1,ver-)
	imreplace(tmpfile1,0,imagina=0,upper=hdthresh,lower=INDEF,radius=0)
	imreplace(tmpfile1,1,imagina=0,lower=hdthresh,upper=INDEF,radius=1)

	imhist (cal, z1=INDEF, z2=INDEF, binwidth=INDEF, nbins=512, autoscale=yes, top_closed=no, hist_type="normal", listout=no, plot_type="line", logy=yes, device="stdgraph")

	print ("Showing histogram of ",cal)
	print ("Input threshold for low sensitivity pix mask:")
	scan(lsthresh)

	tmpfile2 = mktemp("tmp_img.")
	imcopy(cal,tmpfile2,ver-)
	imreplace(tmpfile2,0,imagina=0,upper=lsthresh,lower=INDEF,radius=1)
	imreplace(tmpfile2,1,imagina=0,lower=lsthresh,upper=INDEF,radius=0)
	imarith (tmpfile2, "-", 1, tmpfile2, title="", divzero=0., hparams="", pixtype="", calctype="", verbose=no, noact=no)
	imarith (tmpfile2, "*", -1, tmpfile2, title="", divzero=0., hparams="", pixtype="", calctype="", verbose=no, noact=no)

	imarith (tmpfile1, "+", tmpfile2, bpmask, title="", divzero=0., hparams="", pixtype="", calctype="", verbose=no, noact=no)
	imreplace(bpmask,1,imagina=0, lower=1,upper=INDEF,radius=0)

	imdel(tmpfile1)
	imdel(tmpfile2)
end
