## mkobjmask.cl
## Yosuke Minowa (2008.06.29)

procedure mkobjmask (fflist, objmasklist)

file fflist       {prompt = "List of flat fielded frames with @mark"}
file objmasklist  {prompt = "List of output object mask frames with @mark"}
bool bpmexec      {yes,prompt="Exec bad pixel mask?"}
file bpmask       {prompt = "Bad pixel mask frame"}
char convolve     {"block 3 3",prompt = "Convolution kernel(objmask)"}
int  hsigma       {3,prompt = "Sigma threshold above sky (objmask)"}
int  lsigma       {10,prompt = "Sigma threshold below sky (objmask)"}
int  minpix       {50,prompt = "Minimum number of pixels in detected objects(objmask)"}

struct *list1  {mode = 'h'}
struct *list2  {mode = 'h'}
#
#
begin
	char _fflist, _objmasklist, _bpmask
	char tmp_maskfile, tmp_fffile, tmp_obmimg
	char fname1,fname2
	char conv
	int hsig,lsig,minp
	
	### make objmask ###
	_fflist = fflist
	_objmasklist = objmasklist
	_bpmask = bpmask
	conv = convolve
	hsig = hsigma
	lsig = lsigma
	minp = minpix

	tmp_fffile = mktemp("tmp_file.")
	sections(_fflist,option='fullname',> tmp_fffile)	

	tmp_maskfile = mktemp ("tmp_file.")
	sections (_objmasklist, option='fullname', > tmp_maskfile)

	list1 = tmp_fffile
	list2 = tmp_maskfile

	while(fscan (list1,fname1) == 1) {
		if(bpmexec){
			fixpix(fname1, _bpmask,ver-)
			fixpix(fname1, _bpmask,ver-)
			fixpix(fname1, _bpmask,ver-)
		}

		if (fscan(list2,fname2) == 1) {
			tmp_obmimg = mktemp ("tmp_img.")

			objmasks (fname1, tmp_obmimg, omtype="boolean", skys="", sigmas="", masks="", extnames="", logfiles="STDOUT", blkstep=1, blksize=-10, convolve=conv, hsigma=hsig, lsigma=lsig, hdetect=yes, ldetect=no, neighbors="8", minpix=minp, ngrow=2, agrow=2.)
			objmasks (fname1, fname2, omtype="boolean", skys="", sigmas="", masks=tmp_obmimg//"[pl]", extnames="", logfiles="STDOUT", blkstep=1, blksize=-10, convolve=conv, hsigma=hsig, lsigma=lsig, hdetect=yes, ldetect=no, neighbors="8", minpix=minp, ngrow=2, agrow=2.)
			hedit(fname1,"objmask",fname2//"[pl]",add+,ver-)
			imdel (tmp_obmimg)
		}
	}

	del(tmp_fffile,ver-,>&"dev$null")
	del(tmp_maskfile,ver-,>&"dev$null")

end
