### mksky.cl
### Yosuke Minowa (2008/06/30)

procedure mksky (fflist,masklist, skyimg)

file fflist   {prompt = "List of flat fielded frames with @mark"}
file masklist {prompt = "List of object mask with @mark"}
file skyimg   {prompt = "Output sky frame name"}
int iteranum  {50,prompt = "Max iteration number for statistic"}
int nsigma    {3,prompt = "Sigma rejection limit"}
struct *list1  {mode = 'h'}
struct *list2  {mode = 'h'}
struct *list3  {mode = 'h'}

begin
	char _fflist, _masklist, _skyimg
	char tmp_fffile, tmp_maskfile
	char ff_name,mask_name
	real bg_med
	int itnum,nsig

	_fflist = fflist
	_masklist = masklist
	_skyimg = skyimg

	itnum = iteranum
	nsig = nsigma

	tmp_fffile = mktemp("tmp_file.")
	sections(_fflist,option='fullname',> tmp_fffile)

	tmp_maskfile = mktemp ("tmp_file.")		
	sections (_masklist,option='fullname',>tmp_maskfile)

	list1 = tmp_fffile
	list2 = tmp_maskfile
	
	while (fscan (list1,ff_name) != EOF) {
		if (fscan (list2,mask_name) != EOF) {
			mask_name = mask_name//"[pl]"
			hedit (ff_name, "objmask", mask_name, add=yes, verify=no)
		}
	}
	
	zcombine (_fflist, _skyimg, comb="median", rej="sigclip", proj=no, outtyp="real", offset="none", masktyp="!objmask", maskval=0., blan=0., scal="none", weigh="none", zerop="midpt", lthresh=INDEF, hthresh=INDEF, nlo=1., nhig=1., nkee=1., mcli=yes, lsig=3., hsig=3.)
	

	del (tmp_fffile, ver-, >&"dev$null")
	del (tmp_maskfile, ver-, >&"dev$null")

end
