# zero-shift imcombine
# 2003.04.05  Yosuke Minowa 

procedure zcombine (input, output)

file input  {prompt="List of images to combine"}
file output {prompt="List of output images"}

string comb      {"average",prompt="Type of combine operation"}
string rej       {"none",prompt="Type of rejection"}
bool proj        {no,prompt="Project highest dimension of input images?"}
string outtyp    {"real",prompt="Output image pixel datatype"}
string offset    {"none",prompt="Input image offsets"}
string masktyp   {"none",prompt="Mask type"}
real maskval     {0,prompt="Mask value"}
real blan       {0,prompt="Value if there are no pixels"}

string scal     {"none",prompt="Image scaling"}
string weigh    {"none",prompt="Image weights"}
string zerop     {"midpt",prompt="Image zero point offset"}
real lthresh     {INDEF,prompt="Lower threshold"}
real hthresh     {INDEF,prompt="Upper threshold"}
real nlo         {1,prompt="minmax: Number of low pixels to reject"}
real nhig        {1,prompt="minmax: Number of high pixels to reject"}
real nkee        {1,prompt="Minimum to keep (pos) or maximum to reject (neg)"}
bool mcli        {yes,prompt="Use median in sigma clipping algorithms?"}
real lsig        {3,prompt="Lower sigma clipping factor"}
real hsig        {3,prompt="Upper sigma clipping factor"}

begin

string zcombtmpfile1,zcombtmpfile2,zcombtmpfile3
string zcombtmpimg
string fname

real med,ave,zero
real sum,num

zcombtmpfile1 = mktemp("zcombtmp_file.")

imstat (input, fields="image,"//zerop, lower=INDEF, upper=INDEF, nclip=50, lsigma=3., usigma=3., binwidth=0.1, format=no, cache=no, > zcombtmpfile1)

sum = 0
num = 0

list = zcombtmpfile1

while(fscan(list,fname,med) == 2){
	sum += med
	num += 1
}

ave = sum / num

zcombtmpfile2 = mktemp("zcombtmp_file.")

list = zcombtmpfile1

while(fscan(list,fname,med) == 2){
	zero = ave - med
	print(fname," ",med,zero,>>zcombtmpfile2)
}

print("image "//zerop//" offset")

zcombtmpfile3 = mktemp("zcombtmp_file.")
list = zcombtmpfile2

while(fscan(list,fname,med,zero) == 3){
	zcombtmpimg = mktemp("zcombtmp_img.")
	imarith(fname,"+",zero,zcombtmpimg,ver-)
	print(fname//" ",med,zero)
	print(zcombtmpimg,>> zcombtmpfile3)
}


imcombine ("@"//zcombtmpfile3, output, headers="", bpmasks="", rejmasks="", nrejmasks="", expmasks="", sigmas="", logfile="STDOUT", combine=comb, reject=rej, project=proj, outtype=outtyp, outlimits="", offsets=offset, masktype=masktyp, maskvalue=maskval, blank=blan, scale=scal, zero="none", weight=weigh, statsec="", expname="", lthreshold=lthresh, hthreshold=hthresh, nlow=nlo, nhigh=nhig, nkeep=nkee, mclip=mcli, lsigma=lsig, hsigma=hsig, rdnoise="0.", gain="1.", snoise="0.", sigscale=0.1, pclip=-0.5, grow=0.)

imdel("zcombtmp_img.*")
del(zcombtmpfile1)
del(zcombtmpfile2)
del(zcombtmpfile3)

end


